3 # This is included in commands that either have to be run from the toplevel
4 # of the repository, or with GIT_DIR environment variable properly.
5 # If the GIT_DIR does not look like the right correct git-repository,
8 # Having this variable in your environment would break scripts because
9 # you would cause "cd" to be taken to unexpected places. If you
10 # like CDPATH, define it for your interactive shell sessions without
14 git_broken_path_fix
() {
25 case "$SANE_TOOL_PATH:$elem" in
26 (?
*:/bin | ?
*:/usr
/bin
)
27 path
="$path$sep$SANE_TOOL_PATH"
50 if test -z "$GIT_QUIET"
56 if test -n "$OPTIONS_SPEC"; then
63 [ -n "$OPTIONS_KEEPDASHDASH" ] &&
64 parseopt_extra
="--keep-dashdash"
67 echo "$OPTIONS_SPEC" |
68 git rev-parse --parseopt $parseopt_extra -- "$@
" ||
72 dashless
=$
(basename "$0" |
sed -e 's/-/ /')
74 die
"Usage: $dashless $USAGE"
77 if [ -z "$LONG_USAGE" ]
79 LONG_USAGE
="Usage: $dashless $USAGE"
81 LONG_USAGE
="Usage: $dashless $USAGE
87 -h|
--h|
--he|
--hel|
--help)
94 if [ -z "${GIT_REFLOG_ACTION:+set}" ]
96 GIT_REFLOG_ACTION
="$*"
97 export GIT_REFLOG_ACTION
102 : "${GIT_EDITOR:=$(git config core.editor)}"
103 : "${GIT_EDITOR:=${VISUAL:-${EDITOR}}}"
104 case "$GIT_EDITOR,$TERM" in
106 echo >&2 "No editor specified in GIT_EDITOR, core.editor, VISUAL,"
107 echo >&2 "or EDITOR. Tried to fall back to vi but terminal is dumb."
108 echo >&2 "Please set one of these variables to an appropriate"
109 echo >&2 "editor or run $0 with options that will not cause an"
110 echo >&2 "editor to be invoked (e.g., -m or -F for git-commit)."
114 eval "${GIT_EDITOR:=vi}" '"$@"'
117 is_bare_repository
() {
118 git rev-parse
--is-bare-repository
122 cdup
=$
(git rev-parse
--show-cdup)
125 # The "-P" option says to follow "physical" directory
126 # structure instead of following symbolic links. When cdup is
127 # "../", this means following the ".." entry in the current
128 # directory instead textually removing a symlink path element
129 # from the PWD shell variable. The "-P" behavior is more
130 # consistent with the C-style chdir used by most of Git.
132 echo >&2 "Cannot chdir to $cdup, the toplevel of the working tree"
138 require_work_tree
() {
139 test $
(git rev-parse
--is-inside-work-tree) = true ||
140 die
"fatal: $0 cannot be used without a working tree."
143 get_author_ident_from_commit
() {
146 s/'\''/'\''\\'\'\''/g
148 s/^author \([^<]*\) <[^>]*> .*$/\1/
150 s
/.
*/GIT_AUTHOR_NAME
='\''&'\''/p
153 s
/^author
[^
<]* <\
([^
>]*\
)> .
*$
/\
1/
155 s/.*/GIT_AUTHOR_EMAIL='\''&'\''/p
158 s/^author [^<]* <[^>]*> \(.*\)$/\1/
160 s
/.
*/GIT_AUTHOR_DATE
='\''&'\''/p
165 encoding=$(git config i18n.commitencoding || echo UTF-8)
166 git show -s --pretty=raw --encoding="$encoding" "$1" -- |
167 LANG=C LC_ALL=C sed -ne "$pick_author_script"
170 # Make sure we are in a valid repository of a vintage we understand,
171 # if we require to be in a git repository.
172 if test -z "$NONGIT_OK"
174 GIT_DIR=$(git rev-parse --git-dir) || exit
175 if [ -z "$SUBDIRECTORY_OK" ]
177 test -z "$(git rev-parse --show-cdup)" || {
179 echo >&2 "You need to run this command from the toplevel of the working tree."
183 test -n "$GIT_DIR" && GIT_DIR=$(cd "$GIT_DIR" && pwd) || {
184 echo >&2 "Unable to determine absolute path of git directory"
187 : ${GIT_OBJECT_DIRECTORY="$GIT_DIR/objects"}
190 # Fix some commands on Windows
193 # Windows has its own (incompatible) sort and find